# encoding: utf-8
# license: gpl2p 

### BEGIN LICENSE NOTICE
# This file is part of the interconnect asset ontology framework (IO)
# Copyright (C) 2010 - 2013
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
module Configuration
  CFG_COMMON = {
    :"log.developer_mode" => true,
    :"log.storage.file.enabled" => true,
    :"log.storage.file.loglevel" => Ghun::Log::Level::DEBUG,
    :"log.storage.file.logsource" => Ghun::Log::Source::ALL^Ghun::Log::Source::FILE,
    :"log.storage.file.logtype" => Ghun::Log::Type::ALL,

    :"log.storage.stderr.enabled" => true,
    :"log.storage.stderr.loglevel" => Ghun::Log::Level::DEBUG,
    :"log.storage.stderr.logsource" => Ghun::Log::Source::ALL,
    :"log.storage.stderr.logtype" => Ghun::Log::Type::ALL,

    :"log.queue" => ["error","timing","development_full","remote.err","report"],
    :"log.queue.development_full.enabled" => true,
    :"log.queue.development_full.only_developer" => true,
    :"log.queue.development_full.identifier" => 'development',
    :"log.queue.development_full.loglevel" => Ghun::Log::Level::DEBUG,
    :"log.queue.development_full.logsource" => Ghun::Log::Source::ALL,
    :"log.queue.development_full.logtype" => Ghun::Log::Type::ALL,
    :"log.queue.development_full.storage" => ["file"],

    :"log.queue.report.enabled" => true,
    :"log.queue.report.only_developer" => false,
    :"log.queue.report.identifier" => 'report',
    :"log.queue.report.loglevel" => Ghun::Log::Level::DEBUG,
    :"log.queue.report.logsource" => Ghun::Log::Source::ALL,
    :"log.queue.report.logtype" => Ghun::Log::Type::REPORT,
    :"log.queue.report.storage" => ["file"],

    :"log.queue.remote.err.enabled" => true,
    :"log.queue.remote.err.only_developer" => false,
    :"log.queue.remote.err.identifier" => 'remote.err',
    :"log.queue.remote.err.loglevel" => Ghun::Log::Level::WARNING,
    :"log.queue.remote.err.logsource" => Ghun::Log::Source::REMOTE | Ghun::Log::Source::TARGET | Ghun::Log::Source::DNS,
    :"log.queue.remote.err.logtype" => Ghun::Log::Type::ALL,
    :"log.queue.remote.err.storage" => ["file"],

    :"log.queue.error.enabled" => true,
    :"log.queue.error.only_developer" => false,
    :"log.queue.error.identifier" => 'error',
    :"log.queue.error.loglevel" => Ghun::Log::Level::WARNING,
    :"log.queue.error.logsource" => Ghun::Log::Source::ALL^(Ghun::Log::Source::REMOTE | Ghun::Log::Source::TARGET | Ghun::Log::Source::DNS),
    :"log.queue.error.logtype" => Ghun::Log::Type::ALL,
    :"log.queue.error.storage" => ["stderr","file"],

    :"log.queue.timing.enabled" => true,
    :"log.queue.timing.only_developer" => false,
    :"log.queue.timing.identifier" => 'timing',
    :"log.queue.timing.loglevel" => Ghun::Log::Level::DEBUG,
    :"log.queue.timing.logsource" => Ghun::Log::Source::ALL,
    :"log.queue.timing.logtype" => Ghun::Log::Type::TIMING | Ghun::Log::Type::PROFILING,
    :"log.queue.timing.storage" => ["stderr","file"],

    :"dns.force_tcp" => true,
    :"dns.allow_caching" => true,
    }
end

