# encoding: utf-8
# license: gpl2p 

### BEGIN LICENSE NOTICE
# This file is part of the interconnect asset ontology framework (IO)
# Copyright (C) 2010 - 2013
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
module Iof
  module Parser
    SELECTOR=Ghun::Base::Selector.new("Parser",[:vendor,:type,:connection_type,:connection_version],true,Ghun::Log::Source::PARSER)
    class Base < Ghun::Base::Module
      def initialize(target,data_handler,target_handler)
        super(Ghun::Log::Source::PARSER)
        @target=target
        @data_handler=data_handler
        @target_handler=target_handler
      end

      #step is one of :preparse, :parse, :postparse
      def parse_command(label,step)
        l=label.intern
        c=@target.commands[l]
        r=@target.results[l]
        m="parse_#{l.to_s}".intern
        raise UnexpectedResultError, "No command or no result with label #{l} found" if c.nil?() || r.nil?()
        self.send(m,l,c,r,step)
      end

      def preparse()
        debug "#{self.class}: Preparsing target #{@target.description()}"
        return true
      end

      def parse()
        debug "#{self.class}: Parsing target #{@target.description()}"
        return true
      end

      def postparse()
        debug "#{self.class}: Postparsing target #{@target.description()}"
        return true
      end

    end

    class CLIBase < Base
      def initialize(target,data_handler,target_handler)
        super(target,data_handler,target_handler)
      end
    end

    class CDPBase < Base
      Iof::Parser::SELECTOR.register_member(self,[:cisco,:cdp_ap,:none,nil])
      Iof::Parser::SELECTOR.register_member(self,[:cisco,:cdp_phone,:none,nil])
      def initialize(target,data_handler,target_handler)
        super(target,data_handler,target_handler)
      end
    end

  end
end
