# encoding: utf-8
# license: gpl2p 

### BEGIN LICENSE NOTICE
# This file is part of the interconnect asset ontology framework (IO)
# Copyright (C) 2010 - 2013
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
module Iof
  module Query
    class Base < Ghun::Base::Module
      @@ontology_mutex=Monitor.new()

      def initialize(name,required_tables,with_mapping=false,ontology_file)
        @timer=Ghun::Timing::Timer.new(Ghun::Log::Source::QUERY)
        @timer.register(:reasoner,"Reasoner startup")
        @timer.start(:reasoner)
        super(Ghun::Log::Source::QUERY)
        @name=name
        @required_tables=required_tables
        @ontology=Iof::Ontology::JenaGlue.new(false,false,true,ontology_file)
        @ns=@ontology.default_ns
        @mapper=nil
        @ontology.start()
        if with_mapping then
          @mapper=Iof::Data::Mapper.new()
          @mapper.check_consistency(@ontology)
        end
        @timer.stop(:reasoner)
        @timer.output(:reasoner)
        @lookup=Iof::Query::Lookup.new(@ontology)
        @lookup.register_query_module(@name, @required_tables)
        @lookup.generate_lookup_tables()
      end
      attr_reader :ontology, :mapper, :lookup

      def finish(read_only=true)
        @ontology.finish(read_only)
      end
    end
  end
end
