# encoding: utf-8
# license: gpl2p 

### BEGIN LICENSE NOTICE
# This file is part of the interconnect asset ontology framework (IO)
# Copyright (C) 2010 - 2013
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
module Ghun
  module Log
    class Queue
      include Ghun::Base::Configuration
      #FIXME needs reload and destroy?
      def initialize(name)
        init_configuration()
        @name=name
        @enabled=config[:"log.queue.#{name}.enabled"]
        @only_developer=config[:"log.queue.#{name}.only_developer"]
        @identifier=config[:"log.queue.#{name}.identifier"]
        @loglevel=config[:"log.queue.#{name}.loglevel"]
        @log_source=config[:"log.queue.#{name}.logsource"]
        @log_type=config[:"log.queue.#{name}.logtype"]
        @storage=Array.new()
        storage=config[:"log.queue.#{name}.storage"]
        storage.each do |s|
          @storage << s.intern
        end unless storage.nil?
        @developer=config[:"log.developer_mode"]
        @enabled = @enabled && ( @developer || !@only_developer )
      end

      def enabled?
        @enabled
      end

      def disable
        @enabled=false
      end

      def enable
        @enabled=( @developer || !@only_developer )
      end

      def appropriate_queue?(loglevel,logsource,logtype)
        @enabled && (@loglevel >= loglevel) && ((logsource & @log_source)!=0) && ((logtype & @log_type)!=0)
      end

      def log(message)
        return unless appropriate_queue?(message.log_level,message.log_source,message.log_type)
        return if Ghun::Base::Blackboard.logger.nil?()
        source = message.log_source & @log_source
        type = message.log_type & @log_type
        @storage.each do |s|
          log=Ghun::Base::Blackboard.logger[s]
          log.log(message.log_level,source,type,@identifier,message.message) unless log.nil?()
        end
      end
    end
  end
end
