# encoding: utf-8
# license: gpl2p 

### BEGIN LICENSE NOTICE
# This file is part of the interconnect asset ontology framework (IO)
# Copyright (C) 2010 - 2013
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
module Ghun
  module Output
    class Versioned < Base
      def initialize(timestamp_format=nil,timestamp=nil,symlink_current=true,base=nil)
        super(base)
        @symlink_current=symlink_current
        @timestamp=timestamp
        @timestamp=TimeStamp.new() unless @timestamp
        @timestamp_format=timestamp_format
        @timestamp_format=@timestamp.default_format unless @timestamp_format
      end
      attr_accessor :timestamp, :timestamp_format


      def build_filename(args,create_dir=false)
        ts=@timestamp.send("get_array_#{@timestamp_format}".intern)
        dir=File.join(@base,args[0..-2])
        @@dir_mutex.synchronize {
          FileUtils.mkdir_p(dir) unless Dir.exists?(dir)
        }
        dir_read=dir.clone
        dir_write=dir.clone
        ts.each do |t|
          symlink=File.join(dir_write.clone,'current')
          dir_write=File.join(dir_write,t)
          if @symlink_current
            dir_read=File.join(dir_read,'current')
          else
            dir_read=File.join(dir_read,t)
          end
          @@dir_mutex.synchronize {
            FileUtils.mkdir_p(dir_write) unless Dir.exists?(dir_write)
            if File.exists?(symlink)
              FileUtils.remove_entry_secure(symlink, true)
              FileUtils.ln_sf(t,symlink)
            else
              FileUtils.ln_sf(t,symlink)
            end if @symlink_current
          } if create_dir
        end unless ts.nil?()
        file=args[-1]
        if create_dir
          return dir_write,file
        else
          return dir_read,file
        end
      end
    end
  end
end
