#!/bin/bash

set -eu

%CREDENTIALS%

user=%USER%
host=%HOST%
dir=%DIR%
key="%KEY%"

rm -f /tmp/visa_ssh_key || true
echo "${key}" > /tmp/visa_ssh_key
chmod 400 /tmp/visa_ssh_key

result=""
#machines="$(nova list | grep -vE "+--*+--*+--*+--*+" | tail -n+2 | cut --fields=2 --delimiter='|' |  sed -e 's/[ \t]*//g' | xargs echo)"
machines="$(nova list | grep -v fhdo | grep -v collax | grep -v terminator | grep -vE "+--*+--*+--*+--*+" | tail -n+2 | cut --fields=2 --delimiter='|' |  sed -e 's/[ \t]*//g' | xargs echo)"
for uuid in ${machines}; do
  nova image-create "${uuid}" "IO_VISA_${uuid}"
  snap=$(nova image-list | grep "IO_VISA_" | cut --fields=2 --delimiter='|' | sed -e 's/[ \t]*//g')
  sleep 60
  while nova image-list | grep -E "^. ${snap}" | grep SAVING &> /dev/null; do
    sleep 5
  done

  #scp -q -i /tmp/visa_ssh_key "/var/lib/glance/images/${snap}" "${user}"@"${host}":"${dir}/IO_VISA_${uuid}"
  result="${result}
================================================================================
$(glance show "${snap}")"
  nova image-delete "${snap}"
done

chmod 600 /tmp/visa_ssh_key
rm -f /tmp/visa_ssh_key

echo "${result}" > create_image_cache
echo "${result}"
