# encoding: utf-8
# license: gpl3p 

### BEGIN LICENSE NOTICE
# This file is part of the interconnect asset ontology framework (IO)
# Copyright (C) 2010 - 2013
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
module Iof
  module Target
    visa_generic_constraints=Hash.new()
    visa_generic_constraints[:check_stdout]=true
    visa_generic_constraints[:expect_empty_stdout]=false
    visa_generic_constraints[:expect_nonempty_stdout]=true
    visa_generic_constraints[:check_stderr]=true
    visa_generic_constraints[:expect_empty_stderr]=true
    visa_generic_constraints[:expect_nonempty_stderr]=false
    visa_generic_constraints[:check_exit_code]=true
    visa_generic_constraints[:expect_exit_code]=0
    visa_generic_constraints[:check_signal]=true
    visa_generic_constraints[:expect_signal]=nil

    visa_generic=Hash.new()
#    visa_generic[:nova_list]={:command => "nova list", :constraints => visa_generic_constraints }
#    visa_generic[:nova_details]={:command => "server=$(nova list | grep -vE \"+--*+--*+--*+--*+\" | tail -n+2 | cut --fields=2 --delimiter=\'|\' |  sed -s \'s/[ \t]//g\' | xargs echo); for s in ${server}; do nova show \"${s}\"; echo \"================================================================================\"; done", :constraints => visa_generic_constraints }
    visa_generic[:nova_list]={:command => "nova list | grep -v fhdo | grep -v collax | grep -v terminator", :constraints => visa_generic_constraints }
    visa_generic[:nova_details]={:command => "server=$(nova list | grep -v fhdo | grep -v collax | grep -v terminator | grep -vE \"+--*+--*+--*+--*+\" | tail -n+2 | cut --fields=2 --delimiter=\'|\' |  sed -s \'s/[ \t]//g\' | xargs echo); for s in ${server}; do nova show \"${s}\"; echo \"================================================================================\"; done", :constraints => visa_generic_constraints }
    visa_generic[:nova_create_images]={:command => '', :constraints => visa_generic_constraints }
    visa_generic[:nova_config]={:command => 'sudo cat /etc/nova/nova.conf', :constraints => visa_generic_constraints }

    visa_ovs=visa_generic.clone()
    visa_ovs[:ifconfig]={:command => "ifconfig -a", :constraints => visa_generic_constraints }
    visa_ovs[:ovs_vs_show]={:command => "sudo ovs-vsctl show", :constraints => visa_generic_constraints }
    visa_ovs[:ovs_vs_list_interface]={:command => "sudo ovs-vsctl list Interface", :constraints => visa_generic_constraints }
    visa_ovs[:ovs_vs_list_bridge]={:command => "sudo ovs-vsctl list Bridge", :constraints => visa_generic_constraints }
    visa_ovs[:ovs_vs_list_port]={:command => "sudo ovs-vsctl list Port", :constraints => visa_generic_constraints }

#    COMMAND_SELECTOR.register_member(visa_generic, [:visa,:plain,:ssh,2])
    COMMAND_SELECTOR.register_member(visa_ovs, [:visa,:ovs,:ssh,2])
    COMMAND_SELECTOR.register_member({}, [:visa,:vsa,:none,nil])
#    CONNECTION_SELECTOR.register_member([:ssh,2],[:visa,:plain])
    CONNECTION_SELECTOR.register_member([:ssh,2],[:visa,:ovs])
    CONNECTION_SELECTOR.register_member([:none,nil],[:visa,:vsa])
  end
end
